Index: uspace/drv/bus/usb/ohci/hw_struct/transfer_descriptor.h
===================================================================
--- uspace/drv/bus/usb/ohci/hw_struct/transfer_descriptor.h	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/bus/usb/ohci/hw_struct/transfer_descriptor.h	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -37,6 +37,6 @@
 #include <bool.h>
 #include <stdint.h>
+
 #include "../utils/malloc32.h"
-
 #include "completion_codes.h"
 
@@ -46,52 +46,64 @@
 #define OHCI_TD_MAX_TRANSFER (4 * 1024)
 
+/**
+ * Transfer Descriptor representation.
+ *
+ * See OHCI spec chapter 4.3.1 General Transfer Descriptor on page 19
+ * (pdf page 33) for details.
+ */
 typedef struct td {
+	/** Status field. Do not touch on active TDs. */
 	volatile uint32_t status;
 #define TD_STATUS_ROUND_FLAG (1 << 18)
-#define TD_STATUS_DP_MASK (0x3) /* direction/PID */
+#define TD_STATUS_DP_MASK (0x3) /* Direction/PID */
 #define TD_STATUS_DP_SHIFT (19)
 #define TD_STATUS_DP_SETUP (0x0)
 #define TD_STATUS_DP_OUT (0x1)
 #define TD_STATUS_DP_IN (0x2)
-#define TD_STATUS_DI_MASK (0x7) /* delay interrupt, wait DI frames before int */
+#define TD_STATUS_DI_MASK (0x7) /* Delay interrupt, wait n frames before irq */
 #define TD_STATUS_DI_SHIFT (21)
 #define TD_STATUS_DI_NO_INTERRUPT (0x7)
-#define TD_STATUS_T_MASK (0x3)  /* data toggle 1x = use ED toggle carry */
-#define TD_STATUS_T_SHIFT (24)
-#define TD_STATUS_T_0 (0x2)
-#define TD_STATUS_T_1 (0x3)
-#define TD_STATUS_T_ED (0)
-#define TD_STATUS_EC_MASK (0x3) /* error count */
+#define TD_STATUS_T_FLAG (1 << 24) /* Explicit toggle bit value for this TD */
+#define TD_STATUS_T_USE_TD_FLAG (1 << 25) /* 1 = use bit 24 as toggle bit */
+#define TD_STATUS_EC_MASK (0x3) /* Error count */
 #define TD_STATUS_EC_SHIFT (26)
-#define TD_STATUS_CC_MASK (0xf) /* condition code */
+#define TD_STATUS_CC_MASK (0xf) /* Condition code */
 #define TD_STATUS_CC_SHIFT (28)
 
-	volatile uint32_t cbp; /* current buffer ptr, data to be transfered */
+	/**
+	 * Current buffer pointer.
+	 * Phys address of the first byte to be transferred. */
+	volatile uint32_t cbp;
+
+	/** Pointer to the next TD in chain. 16-byte aligned. */
 	volatile uint32_t next;
 #define TD_NEXT_PTR_MASK (0xfffffff0)
 #define TD_NEXT_PTR_SHIFT (0)
 
-	volatile uint32_t be; /* buffer end, address of the last byte */
+	/**
+	 * Buffer end.
+	 * Phys address of the last byte of the transfer.
+	 * @note this does not have to be on the same page as cbp.
+	 */
+	volatile uint32_t be;
 } __attribute__((packed)) td_t;
 
-void td_init(td_t *instance,
+void td_init(td_t *instance, const td_t *next,
     usb_direction_t dir, const void *buffer, size_t size, int toggle);
 
-inline static void td_set_next(td_t *instance, td_t *next)
+/**
+ * Check TD for completion.
+ * @param instance TD structure.
+ * @return true if the TD was accessed and processed by hw, false otherwise.
+ */
+inline static bool td_is_finished(const td_t *instance)
 {
 	assert(instance);
-	instance->next = addr_to_phys(next) & TD_NEXT_PTR_MASK;
-}
-
-inline static bool td_is_finished(td_t *instance)
-{
-	assert(instance);
-	int cc = (instance->status >> TD_STATUS_CC_SHIFT) & TD_STATUS_CC_MASK;
-	/* something went wrong, error code is set */
+	const int cc =
+	    (instance->status >> TD_STATUS_CC_SHIFT) & TD_STATUS_CC_MASK;
+	/* This value is changed on transfer completion,
+	 * either to CC_NOERROR or and error code.
+	 * See OHCI spec 4.3.1.3.5 p. 23 (pdf 37) */
 	if (cc != CC_NOACCESS1 && cc != CC_NOACCESS2) {
-		return true;
-	}
-	/* everything done */
-	if (cc == CC_NOERROR && instance->cbp == 0) {
 		return true;
 	}
@@ -99,16 +111,29 @@
 }
 
-static inline int td_error(td_t *instance)
+/**
+ * Get error code that indicates transfer status.
+ * @param instance TD structure.
+ * @return Error code.
+ */
+static inline int td_error(const td_t *instance)
 {
 	assert(instance);
-	int cc = (instance->status >> TD_STATUS_CC_SHIFT) & TD_STATUS_CC_MASK;
+	const int cc =
+	    (instance->status >> TD_STATUS_CC_SHIFT) & TD_STATUS_CC_MASK;
 	return cc_to_rc(cc);
 }
 
+/**
+ * Get remaining portion of buffer to be read/written
+ * @param instance TD structure
+ * @return size of remaining buffer.
+ */
 static inline size_t td_remain_size(td_t *instance)
 {
 	assert(instance);
+	/* Current buffer pointer is cleared on successful transfer */
 	if (instance->cbp == 0)
 		return 0;
+	/* Buffer end points to the last byte of transfer buffer, so add 1 */
 	return instance->be - instance->cbp + 1;
 }
Index: uspace/drv/bus/usb/ohci/main.c
===================================================================
--- uspace/drv/bus/usb/ohci/main.c	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/bus/usb/ohci/main.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -48,7 +48,7 @@
  * @return Error code.
  */
-static int ohci_add_device(ddf_dev_t *device)
+static int ohci_dev_add(ddf_dev_t *device)
 {
-	usb_log_debug("ohci_add_device() called\n");
+	usb_log_debug("ohci_dev_add() called\n");
 	assert(device);
 
@@ -65,5 +65,5 @@
 /*----------------------------------------------------------------------------*/
 static driver_ops_t ohci_driver_ops = {
-	.add_device = ohci_add_device,
+	.dev_add = ohci_dev_add,
 };
 /*----------------------------------------------------------------------------*/
Index: uspace/drv/bus/usb/ohci/ohci.c
===================================================================
--- uspace/drv/bus/usb/ohci/ohci.c	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/bus/usb/ohci/ohci.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -76,24 +76,16 @@
 }
 /*----------------------------------------------------------------------------*/
-/** Get address of the device identified by handle.
- *
- * @param[in] dev DDF instance of the device to use.
- * @param[in] iid (Unused).
- * @param[in] call Pointer to the call that represents interrupt.
- */
-static int usb_iface_get_address(
-    ddf_fun_t *fun, devman_handle_t handle, usb_address_t *address)
+/** Get USB address assigned to root hub.
+ *
+ * @param[in] fun Root hub function.
+ * @param[out] address Store the address here.
+ * @return Error code.
+ */
+static int rh_get_my_address(ddf_fun_t *fun, usb_address_t *address)
 {
 	assert(fun);
-	usb_device_manager_t *manager =
-	    &dev_to_ohci(fun->dev)->hc.generic.dev_manager;
-
-	const usb_address_t addr = usb_device_manager_find(manager, handle);
-	if (addr < 0) {
-		return addr;
-	}
 
 	if (address != NULL) {
-		*address = addr;
+		*address = dev_to_ohci(fun->dev)->hc.rh.address;
 	}
 
@@ -107,5 +99,5 @@
  * @return Error code.
  */
-static int usb_iface_get_hc_handle(
+static int rh_get_hc_handle(
     ddf_fun_t *fun, devman_handle_t *handle)
 {
@@ -121,6 +113,6 @@
 /** Root hub USB interface */
 static usb_iface_t usb_iface = {
-	.get_hc_handle = usb_iface_get_hc_handle,
-	.get_address = usb_iface_get_address
+	.get_hc_handle = rh_get_hc_handle,
+	.get_my_address = rh_get_my_address,
 };
 /*----------------------------------------------------------------------------*/
Index: uspace/drv/bus/usb/ohci/ohci.ma
===================================================================
--- uspace/drv/bus/usb/ohci/ohci.ma	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/bus/usb/ohci/ohci.ma	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -1,15 +1,1 @@
-10 pci/ven=106b&dev=0026
-10 pci/ven=106b&dev=003f
-10 pci/ven=10de&dev=0aa5
-
-10 pci/ven=1002&dev=4374
-10 pci/ven=1002&dev=4375
-
-10 pci/ven=1002&dev=4387
-10 pci/ven=1002&dev=4388
-10 pci/ven=1002&dev=4389
-10 pci/ven=1002&dev=438a
-10 pci/ven=1002&dev=438b
-10 pci/ven=1002&dev=4397
-10 pci/ven=1002&dev=4398
-10 pci/ven=1002&dev=4399
+10 pci/class=0c&subclass=03&progif=10
Index: uspace/drv/bus/usb/ohci/ohci_batch.c
===================================================================
--- uspace/drv/bus/usb/ohci/ohci_batch.c	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/bus/usb/ohci/ohci_batch.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -52,7 +52,6 @@
 	if (!ohci_batch)
 		return;
-	unsigned i = 0;
 	if (ohci_batch->tds) {
-		for (; i< ohci_batch->td_count; ++i) {
+		for (unsigned i = 0; i < ohci_batch->td_count; ++i) {
 			if (i != ohci_batch->leave_td)
 				free32(ohci_batch->tds[i]);
@@ -60,5 +59,5 @@
 		free(ohci_batch->tds);
 	}
-	usb_transfer_batch_dispose(ohci_batch->usb_batch);
+	usb_transfer_batch_destroy(ohci_batch->usb_batch);
 	free32(ohci_batch->device_buffer);
 	free(ohci_batch);
@@ -107,6 +106,6 @@
 	ohci_batch->tds[0] = ohci_endpoint_get(usb_batch->ep)->td;
 	ohci_batch->leave_td = 0;
-	unsigned i = 1;
-	for (; i <= ohci_batch->td_count; ++i) {
+
+	for (unsigned i = 1; i <= ohci_batch->td_count; ++i) {
 		ohci_batch->tds[i] = malloc32(sizeof(td_t));
 		CHECK_NULL_DISPOSE_RET(ohci_batch->tds[i],
@@ -160,47 +159,82 @@
 	usb_log_debug("Batch %p checking %zu td(s) for completion.\n",
 	    ohci_batch->usb_batch, ohci_batch->td_count);
-	usb_log_debug2("ED: %x:%x:%x:%x.\n",
+	usb_log_debug2("ED: %08x:%08x:%08x:%08x.\n",
 	    ohci_batch->ed->status, ohci_batch->ed->td_head,
 	    ohci_batch->ed->td_tail, ohci_batch->ed->next);
 
-	size_t i = 0;
-	for (; i < ohci_batch->td_count; ++i) {
+	if (!ed_inactive(ohci_batch->ed) && ed_transfer_pending(ohci_batch->ed))
+		return false;
+
+	/* Now we may be sure that either the ED is inactive because of errors
+	 * or all transfer descriptors completed successfully */
+
+	/* Assume all data got through */
+	ohci_batch->usb_batch->transfered_size =
+	    ohci_batch->usb_batch->buffer_size;
+
+	/* Assume we will leave the last(unused) TD behind */
+	ohci_batch->leave_td = ohci_batch->td_count;
+
+	/* Check all TDs */
+	for (size_t i = 0; i < ohci_batch->td_count; ++i) {
 		assert(ohci_batch->tds[i] != NULL);
-		usb_log_debug("TD %zu: %x:%x:%x:%x.\n", i,
+		usb_log_debug("TD %zu: %08x:%08x:%08x:%08x.\n", i,
 		    ohci_batch->tds[i]->status, ohci_batch->tds[i]->cbp,
 		    ohci_batch->tds[i]->next, ohci_batch->tds[i]->be);
-		if (!td_is_finished(ohci_batch->tds[i])) {
-			return false;
-		}
+
+		/* If the TD got all its data through, it will report 0 bytes
+		 * remain, the sole exception is INPUT with data rounding flag
+		 * (short), i.e. every INPUT. Nice thing is that short packets
+		 * will correctly report remaining data, thus making
+		 * this computation correct (short packets need to be produced
+		 * by the last TD)
+		 * NOTE: This also works for CONTROL transfer as
+		 * the first TD will return 0 remain.
+		 * NOTE: Short packets don't break the assumption that
+		 * we leave the very last(unused) TD behind.
+		 */
+		ohci_batch->usb_batch->transfered_size
+		    -= td_remain_size(ohci_batch->tds[i]);
+
 		ohci_batch->usb_batch->error = td_error(ohci_batch->tds[i]);
 		if (ohci_batch->usb_batch->error != EOK) {
-			usb_log_debug("Batch %p found error TD(%zu):%x.\n",
+			usb_log_debug("Batch %p found error TD(%zu):%08x.\n",
 			    ohci_batch->usb_batch, i,
 			    ohci_batch->tds[i]->status);
-			/* Make sure TD queue is empty (one TD),
-			 * ED should be marked as halted */
-			ohci_batch->ed->td_tail =
-			    (ohci_batch->ed->td_head & ED_TDTAIL_PTR_MASK);
-			++i;
+
+			/* ED should be stopped because of errors */
+			assert((ohci_batch->ed->td_head & ED_TDHEAD_HALTED_FLAG) != 0);
+
+			/* Now we have a problem: we don't know what TD
+			 * the head pointer points to, the retiring rules
+			 * described in specs say it should be the one after
+			 * the failed one so set the tail pointer accordingly.
+			 * It will be the one TD we leave behind.
+			 */
+			ohci_batch->leave_td = i + 1;
+
+			/* Check TD assumption */
+			const uint32_t pa = addr_to_phys(
+			    ohci_batch->tds[ohci_batch->leave_td]);
+			assert((ohci_batch->ed->td_head & ED_TDTAIL_PTR_MASK)
+			    == pa);
+
+			ed_set_tail_td(ohci_batch->ed,
+			    ohci_batch->tds[ohci_batch->leave_td]);
+
+			/* Clear possible ED HALT */
+			ohci_batch->ed->td_head &= ~ED_TDHEAD_HALTED_FLAG;
 			break;
 		}
 	}
-
-	assert(i <= ohci_batch->td_count);
-	ohci_batch->leave_td = i;
-
+	assert(ohci_batch->usb_batch->transfered_size <=
+	    ohci_batch->usb_batch->buffer_size);
+
+	/* Store the remaining TD */
 	ohci_endpoint_t *ohci_ep = ohci_endpoint_get(ohci_batch->usb_batch->ep);
 	assert(ohci_ep);
 	ohci_ep->td = ohci_batch->tds[ohci_batch->leave_td];
-	assert(i > 0);
-	ohci_batch->usb_batch->transfered_size =
-	    ohci_batch->usb_batch->buffer_size;
-	for (--i;i < ohci_batch->td_count; ++i)
-		ohci_batch->usb_batch->transfered_size
-		    -= td_remain_size(ohci_batch->tds[i]);
-
-	/* Clear possible ED HALT */
-	ohci_batch->ed->td_head &= ~ED_TDHEAD_HALTED_FLAG;
-	/* just make sure that we are leaving the right TD behind */
+
+	/* Make sure that we are leaving the right TD behind */
 	const uint32_t pa = addr_to_phys(ohci_ep->td);
 	assert(pa == (ohci_batch->ed->td_head & ED_TDHEAD_PTR_MASK));
@@ -217,5 +251,5 @@
 {
 	assert(ohci_batch);
-	ed_set_end_td(ohci_batch->ed, ohci_batch->tds[ohci_batch->td_count]);
+	ed_set_tail_td(ohci_batch->ed, ohci_batch->tds[ohci_batch->td_count]);
 }
 /*----------------------------------------------------------------------------*/
@@ -234,5 +268,5 @@
 	assert(ohci_batch->usb_batch);
 	assert(dir == USB_DIRECTION_IN || dir == USB_DIRECTION_OUT);
-	usb_log_debug("Using ED(%p): %x:%x:%x:%x.\n", ohci_batch->ed,
+	usb_log_debug("Using ED(%p): %08x:%08x:%08x:%08x.\n", ohci_batch->ed,
 	    ohci_batch->ed->status, ohci_batch->ed->td_tail,
 	    ohci_batch->ed->td_head, ohci_batch->ed->next);
@@ -247,14 +281,14 @@
 	const usb_direction_t status_dir = reverse_dir[dir];
 
-	/* setup stage */
-	td_init(ohci_batch->tds[0], USB_DIRECTION_BOTH, buffer,
-		ohci_batch->usb_batch->setup_size, toggle);
-	td_set_next(ohci_batch->tds[0], ohci_batch->tds[1]);
-	usb_log_debug("Created CONTROL SETUP TD: %x:%x:%x:%x.\n",
+	/* Setup stage */
+	td_init(
+	    ohci_batch->tds[0], ohci_batch->tds[1], USB_DIRECTION_BOTH,
+	    buffer, ohci_batch->usb_batch->setup_size, toggle);
+	usb_log_debug("Created CONTROL SETUP TD: %08x:%08x:%08x:%08x.\n",
 	    ohci_batch->tds[0]->status, ohci_batch->tds[0]->cbp,
 	    ohci_batch->tds[0]->next, ohci_batch->tds[0]->be);
 	buffer += ohci_batch->usb_batch->setup_size;
 
-	/* data stage */
+	/* Data stage */
 	size_t td_current = 1;
 	size_t remain_size = ohci_batch->usb_batch->buffer_size;
@@ -265,9 +299,8 @@
 		toggle = 1 - toggle;
 
-		td_init(ohci_batch->tds[td_current], data_dir, buffer,
-		    transfer_size, toggle);
-		td_set_next(ohci_batch->tds[td_current],
-		    ohci_batch->tds[td_current + 1]);
-		usb_log_debug("Created CONTROL DATA TD: %x:%x:%x:%x.\n",
+		td_init(ohci_batch->tds[td_current],
+		    ohci_batch->tds[td_current + 1],
+		    data_dir, buffer, transfer_size, toggle);
+		usb_log_debug("Created CONTROL DATA TD: %08x:%08x:%08x:%08x.\n",
 		    ohci_batch->tds[td_current]->status,
 		    ohci_batch->tds[td_current]->cbp,
@@ -281,10 +314,9 @@
 	}
 
-	/* status stage */
+	/* Status stage */
 	assert(td_current == ohci_batch->td_count - 1);
-	td_init(ohci_batch->tds[td_current], status_dir, NULL, 0, 1);
-	td_set_next(ohci_batch->tds[td_current],
-	    ohci_batch->tds[td_current + 1]);
-	usb_log_debug("Created CONTROL STATUS TD: %x:%x:%x:%x.\n",
+	td_init(ohci_batch->tds[td_current], ohci_batch->tds[td_current + 1],
+	    status_dir, NULL, 0, 1);
+	usb_log_debug("Created CONTROL STATUS TD: %08x:%08x:%08x:%08x.\n",
 	    ohci_batch->tds[td_current]->status,
 	    ohci_batch->tds[td_current]->cbp,
@@ -312,5 +344,5 @@
 	assert(ohci_batch->usb_batch);
 	assert(dir == USB_DIRECTION_IN || dir == USB_DIRECTION_OUT);
-	usb_log_debug("Using ED(%p): %x:%x:%x:%x.\n", ohci_batch->ed,
+	usb_log_debug("Using ED(%p): %08x:%08x:%08x:%08x.\n", ohci_batch->ed,
 	    ohci_batch->ed->status, ohci_batch->ed->td_tail,
 	    ohci_batch->ed->td_head, ohci_batch->ed->next);
@@ -323,10 +355,9 @@
 		    ? OHCI_TD_MAX_TRANSFER : remain_size;
 
-		td_init(ohci_batch->tds[td_current], dir, buffer,
-		    transfer_size, -1);
-		td_set_next(ohci_batch->tds[td_current],
-		    ohci_batch->tds[td_current + 1]);
-
-		usb_log_debug("Created DATA TD: %x:%x:%x:%x.\n",
+		td_init(
+		    ohci_batch->tds[td_current], ohci_batch->tds[td_current + 1],
+		    dir, buffer, transfer_size, -1);
+
+		usb_log_debug("Created DATA TD: %08x:%08x:%08x:%08x.\n",
 		    ohci_batch->tds[td_current]->status,
 		    ohci_batch->tds[td_current]->cbp,
Index: uspace/drv/bus/usb/ohci/ohci_endpoint.c
===================================================================
--- uspace/drv/bus/usb/ohci/ohci_endpoint.c	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/bus/usb/ohci/ohci_endpoint.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -62,23 +62,8 @@
 }
 /*----------------------------------------------------------------------------*/
-/** Disposes hcd endpoint structure
- *
- * @param[in] hcd_ep endpoint structure
- */
-static void ohci_endpoint_fini(endpoint_t *ep)
-{
-	ohci_endpoint_t *instance = ep->hc_data.data;
-	hc_dequeue_endpoint(instance->hcd->private_data, ep);
-	if (instance) {
-		free32(instance->ed);
-		free32(instance->td);
-		free(instance);
-	}
-}
-/*----------------------------------------------------------------------------*/
 /** Creates new hcd endpoint representation.
  *
  * @param[in] ep USBD endpoint structure
- * @return pointer to a new hcd endpoint structure, NULL on failure.
+ * @return Error code.
  */
 int ohci_endpoint_init(hcd_t *hcd, endpoint_t *ep)
@@ -102,11 +87,28 @@
 	}
 
-	ed_init(ohci_ep->ed, ep);
-	ed_set_td(ohci_ep->ed, ohci_ep->td);
+	ed_init(ohci_ep->ed, ep, ohci_ep->td);
 	endpoint_set_hc_data(
-	    ep, ohci_ep, ohci_endpoint_fini, ohci_ep_toggle_get, ohci_ep_toggle_set);
-	ohci_ep->hcd = hcd;
+	    ep, ohci_ep, ohci_ep_toggle_get, ohci_ep_toggle_set);
 	hc_enqueue_endpoint(hcd->private_data, ep);
 	return EOK;
+}
+/*----------------------------------------------------------------------------*/
+/** Disposes hcd endpoint structure
+ *
+ * @param[in] hcd driver using this instance.
+ * @param[in] ep endpoint structure.
+ */
+void ohci_endpoint_fini(hcd_t *hcd, endpoint_t *ep)
+{
+	assert(hcd);
+	assert(ep);
+	ohci_endpoint_t *instance = ohci_endpoint_get(ep);
+	hc_dequeue_endpoint(hcd->private_data, ep);
+	if (instance) {
+		free32(instance->ed);
+		free32(instance->td);
+		free(instance);
+	}
+	endpoint_clear_hc_data(ep);
 }
 /**
Index: uspace/drv/bus/usb/ohci/ohci_endpoint.h
===================================================================
--- uspace/drv/bus/usb/ohci/ohci_endpoint.h	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/bus/usb/ohci/ohci_endpoint.h	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -51,9 +51,8 @@
 	/** Linked list used by driver software */
 	link_t link;
-	/** Device using this ep */
-	hcd_t *hcd;
 } ohci_endpoint_t;
 
 int ohci_endpoint_init(hcd_t *hcd, endpoint_t *ep);
+void ohci_endpoint_fini(hcd_t *hcd, endpoint_t *ep);
 
 /** Get and convert assigned ohci_endpoint_t structure
@@ -61,5 +60,5 @@
  * @return Pointer to assigned hcd endpoint structure
  */
-static inline ohci_endpoint_t * ohci_endpoint_get(endpoint_t *ep)
+static inline ohci_endpoint_t * ohci_endpoint_get(const endpoint_t *ep)
 {
 	assert(ep);
Index: uspace/drv/bus/usb/ohci/ohci_regs.h
===================================================================
--- uspace/drv/bus/usb/ohci/ohci_regs.h	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/bus/usb/ohci/ohci_regs.h	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -26,5 +26,5 @@
  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  */
-/** @addtogroup drvusbohcihc
+/** @addtogroup drvusbohci
  * @{
  */
Index: uspace/drv/bus/usb/ohci/pci.c
===================================================================
--- uspace/drv/bus/usb/ohci/pci.c	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/bus/usb/ohci/pci.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -85,6 +85,5 @@
 	bool irq_found = false;
 
-	size_t i;
-	for (i = 0; i < hw_resources.count; i++) {
+	for (size_t i = 0; i < hw_resources.count; i++) {
 		hw_resource_t *res = &hw_resources.resources[i];
 		switch (res->type) {
Index: uspace/drv/bus/usb/ohci/root_hub.c
===================================================================
--- uspace/drv/bus/usb/ohci/root_hub.c	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/bus/usb/ohci/root_hub.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -35,6 +35,9 @@
 #include <errno.h>
 #include <str_error.h>
+#include <fibril_synch.h>
 
 #include <usb/debug.h>
+#include <usb/dev/request.h>
+#include <usb/classes/hub.h>
 
 #include "root_hub.h"
@@ -43,7 +46,4 @@
 #include <usb/dev/driver.h>
 #include "ohci_regs.h"
-
-#include <usb/dev/request.h>
-#include <usb/classes/hub.h>
 
 /**
@@ -108,11 +108,13 @@
 static void create_serialized_hub_descriptor(rh_t *instance);
 static void rh_init_descriptors(rh_t *instance);
-static uint16_t create_interrupt_mask(rh_t *instance);
-static int get_status(rh_t *instance, usb_transfer_batch_t *request);
-static int get_descriptor(rh_t *instance, usb_transfer_batch_t *request);
-static int set_feature(rh_t *instance, usb_transfer_batch_t *request);
-static int clear_feature(rh_t *instance, usb_transfer_batch_t *request);
-static int set_feature_port(rh_t *instance, uint16_t feature, uint16_t port);
-static int clear_feature_port(rh_t *instance, uint16_t feature, uint16_t port);
+static uint16_t create_interrupt_mask(const rh_t *instance);
+static int get_status(const rh_t *instance, usb_transfer_batch_t *request);
+static int get_descriptor(const rh_t *instance, usb_transfer_batch_t *request);
+static int set_feature(const rh_t *instance, usb_transfer_batch_t *request);
+static int clear_feature(const rh_t *instance, usb_transfer_batch_t *request);
+static int set_feature_port(
+    const rh_t *instance, uint16_t feature, uint16_t port);
+static int clear_feature_port(
+    const rh_t *instance, uint16_t feature, uint16_t port);
 static int control_request(rh_t *instance, usb_transfer_batch_t *request);
 static inline void interrupt_request(
@@ -153,9 +155,11 @@
 	instance->unfinished_interrupt_transfer = NULL;
 
-#ifdef OHCI_POWER_SWITCH_no
+#if defined OHCI_POWER_SWITCH_no
 	/* Set port power mode to no power-switching. (always on) */
 	instance->registers->rh_desc_a |= RHDA_NPS_FLAG;
+
 	/* Set to no over-current reporting */
 	instance->registers->rh_desc_a |= RHDA_NOCP_FLAG;
+
 #elif defined OHCI_POWER_SWITCH_ganged
 	/* Set port power mode to no ganged power-switching. */
@@ -163,4 +167,5 @@
 	instance->registers->rh_desc_a &= ~RHDA_PSM_FLAG;
 	instance->registers->rh_status = RHS_CLEAR_GLOBAL_POWER;
+
 	/* Set to global over-current */
 	instance->registers->rh_desc_a &= ~RHDA_NOCP_FLAG;
@@ -174,7 +179,9 @@
 	instance->registers->rh_desc_b &= (RHDB_PCC_MASK << RHDB_PCC_SHIFT);
 	instance->registers->rh_status = RHS_CLEAR_GLOBAL_POWER;
+
 	/* Return control to per port state */
 	instance->registers->rh_desc_b |=
 		((1 << (instance->port_count + 1)) - 1) << RHDB_PCC_SHIFT;
+
 	/* Set per port over-current */
 	instance->registers->rh_desc_a &= ~RHDA_NOCP_FLAG;
@@ -182,4 +189,5 @@
 #endif
 
+	fibril_mutex_initialize(&instance->guard);
 	rh_init_descriptors(instance);
 
@@ -209,13 +217,16 @@
 	case USB_TRANSFER_INTERRUPT:
 		usb_log_debug("Root hub got INTERRUPT packet\n");
+		fibril_mutex_lock(&instance->guard);
+		assert(instance->unfinished_interrupt_transfer == NULL);
 		const uint16_t mask = create_interrupt_mask(instance);
 		if (mask == 0) {
 			usb_log_debug("No changes..\n");
-			assert(instance->unfinished_interrupt_transfer == NULL);
 			instance->unfinished_interrupt_transfer = request;
+			fibril_mutex_unlock(&instance->guard);
 			return;
 		}
 		usb_log_debug("Processing changes...\n");
 		interrupt_request(request, mask, instance->interrupt_mask_size);
+		fibril_mutex_unlock(&instance->guard);
 		break;
 
@@ -224,5 +235,5 @@
 		usb_transfer_batch_finish_error(request, NULL, 0, EINVAL);
 	}
-	usb_transfer_batch_dispose(request);
+	usb_transfer_batch_destroy(request);
 }
 /*----------------------------------------------------------------------------*/
@@ -237,14 +248,15 @@
 	assert(instance);
 
-	if (!instance->unfinished_interrupt_transfer)
-		return;
-
-	usb_log_debug("Finalizing interrupt transfer\n");
-	const uint16_t mask = create_interrupt_mask(instance);
-	interrupt_request(instance->unfinished_interrupt_transfer,
-	    mask, instance->interrupt_mask_size);
-	usb_transfer_batch_dispose(instance->unfinished_interrupt_transfer);
-
-	instance->unfinished_interrupt_transfer = NULL;
+	fibril_mutex_lock(&instance->guard);
+	if (instance->unfinished_interrupt_transfer) {
+		usb_log_debug("Finalizing interrupt transfer\n");
+		const uint16_t mask = create_interrupt_mask(instance);
+		interrupt_request(instance->unfinished_interrupt_transfer,
+		    mask, instance->interrupt_mask_size);
+		usb_transfer_batch_destroy(
+		    instance->unfinished_interrupt_transfer);
+		instance->unfinished_interrupt_transfer = NULL;
+	}
+	fibril_mutex_unlock(&instance->guard);
 }
 /*----------------------------------------------------------------------------*/
@@ -342,5 +354,5 @@
  * @return Mask of changes.
  */
-uint16_t create_interrupt_mask(rh_t *instance)
+uint16_t create_interrupt_mask(const rh_t *instance)
 {
 	assert(instance);
@@ -351,6 +363,5 @@
 		mask |= 1;
 	}
-	size_t port = 1;
-	for (; port <= instance->port_count; ++port) {
+	for (size_t port = 1; port <= instance->port_count; ++port) {
 		/* Write-clean bits are those that indicate change */
 		if (RHPS_CHANGE_WC_MASK
@@ -373,5 +384,5 @@
  * @return error code
  */
-int get_status(rh_t *instance, usb_transfer_batch_t *request)
+int get_status(const rh_t *instance, usb_transfer_batch_t *request)
 {
 	assert(instance);
@@ -419,5 +430,5 @@
  * @return Error code
  */
-int get_descriptor(rh_t *instance, usb_transfer_batch_t *request)
+int get_descriptor(const rh_t *instance, usb_transfer_batch_t *request)
 {
 	assert(instance);
@@ -497,5 +508,5 @@
  * @return error code
  */
-int set_feature_port(rh_t *instance, uint16_t feature, uint16_t port)
+int set_feature_port(const rh_t *instance, uint16_t feature, uint16_t port)
 {
 	assert(instance);
@@ -536,5 +547,5 @@
  * @return error code
  */
-int clear_feature_port(rh_t *instance, uint16_t feature, uint16_t port)
+int clear_feature_port(const rh_t *instance, uint16_t feature, uint16_t port)
 {
 	assert(instance);
@@ -593,5 +604,5 @@
  * @return error code
  */
-int set_feature(rh_t *instance, usb_transfer_batch_t *request)
+int set_feature(const rh_t *instance, usb_transfer_batch_t *request)
 {
 	assert(instance);
@@ -629,5 +640,5 @@
  * @return error code
  */
-int clear_feature(rh_t *instance, usb_transfer_batch_t *request)
+int clear_feature(const rh_t *instance, usb_transfer_batch_t *request)
 {
 	assert(instance);
@@ -636,5 +647,7 @@
 	const usb_device_request_setup_packet_t *setup_request =
 	    (usb_device_request_setup_packet_t *) request->setup_buffer;
+
 	request->transfered_size = 0;
+
 	switch (setup_request->request_type)
 	{
@@ -648,6 +661,7 @@
 		/*
 		 * Chapter 11.16.2 specifies that only C_HUB_LOCAL_POWER and
-		 * C_HUB_OVER_CURRENT are supported. C_HUB_OVER_CURRENT is represented
-		 * by OHCI RHS_OCIC_FLAG. C_HUB_LOCAL_POWER is not supported
+		 * C_HUB_OVER_CURRENT are supported.
+		 * C_HUB_OVER_CURRENT is represented by OHCI RHS_OCIC_FLAG.
+		 * C_HUB_LOCAL_POWER is not supported
 		 * as root hubs do not support local power status feature.
 		 * (OHCI pg. 127) */
@@ -721,4 +735,5 @@
 		    "additional data\n");
 		return clear_feature(instance, request);
+
 	case USB_DEVREQ_SET_FEATURE:
 		usb_log_debug2("Processing request without "
Index: uspace/drv/bus/usb/ohci/root_hub.h
===================================================================
--- uspace/drv/bus/usb/ohci/root_hub.h	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/bus/usb/ohci/root_hub.h	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -47,4 +47,5 @@
  */
 typedef struct rh {
+	fibril_mutex_t guard;
 	/** pointer to ohci driver registers */
 	ohci_regs_t *registers;
Index: uspace/drv/bus/usb/ohci/utils/malloc32.h
===================================================================
--- uspace/drv/bus/usb/ohci/utils/malloc32.h	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/bus/usb/ohci/utils/malloc32.h	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -41,4 +41,10 @@
 #include <as.h>
 
+/* Generic TDs and EDs require 16byte alignment,
+ * Isochronous TD require 32byte alignment,
+ * buffers do not have to be aligned.
+ */
+#define OHCI_ALIGN 32
+
 /** Get physical address translation
  *
@@ -62,5 +68,5 @@
  */
 static inline void * malloc32(size_t size)
-	{ return memalign(size, size); }
+	{ return memalign(OHCI_ALIGN, size); }
 /*----------------------------------------------------------------------------*/
 /** Physical mallocator simulator
@@ -69,5 +75,5 @@
  */
 static inline void free32(void *addr)
-	{ if (addr) free(addr); }
+	{ free(addr); }
 #endif
 /**
Index: uspace/drv/bus/usb/uhci/hc.c
===================================================================
--- uspace/drv/bus/usb/uhci/hc.c	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/bus/usb/uhci/hc.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -192,23 +192,17 @@
 	    "Device registers at %p (%zuB) accessible.\n", io, reg_size);
 
-	ret = hcd_init(&instance->generic, BANDWIDTH_AVAILABLE_USB11,
-	    bandwidth_count_usb11);
-	CHECK_RET_RETURN(ret, "Failed to initialize HCD generic driver: %s.\n",
+	ret = hc_init_mem_structures(instance);
+	CHECK_RET_RETURN(ret,
+	    "Failed to initialize UHCI memory structures: %s.\n",
 	    str_error(ret));
+
+#undef CHECK_RET_RETURN
+
+	hcd_init(&instance->generic, USB_SPEED_FULL,
+	    BANDWIDTH_AVAILABLE_USB11, bandwidth_count_usb11);
 
 	instance->generic.private_data = instance;
 	instance->generic.schedule = hc_schedule;
 	instance->generic.ep_add_hook = NULL;
-
-#undef CHECK_RET_DEST_FUN_RETURN
-
-	ret = hc_init_mem_structures(instance);
-	if (ret != EOK) {
-		usb_log_error(
-		    "Failed to initialize UHCI memory structures: %s.\n",
-		    str_error(ret));
-		hcd_destroy(&instance->generic);
-		return ret;
-	}
 
 	hc_init_hw(instance);
@@ -299,6 +293,6 @@
 	const uint32_t queue = LINK_POINTER_QH(
 	        addr_to_phys(instance->transfers_interrupt.queue_head));
-	unsigned i = 0;
-	for(; i < UHCI_FRAME_LIST_COUNT; ++i) {
+
+	for (unsigned i = 0; i < UHCI_FRAME_LIST_COUNT; ++i) {
 		instance->frame_list[i] = queue;
 	}
Index: uspace/drv/bus/usb/uhci/main.c
===================================================================
--- uspace/drv/bus/usb/uhci/main.c	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/bus/usb/uhci/main.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -43,8 +43,8 @@
 #define NAME "uhci"
 
-static int uhci_add_device(ddf_dev_t *device);
+static int uhci_dev_add(ddf_dev_t *device);
 /*----------------------------------------------------------------------------*/
 static driver_ops_t uhci_driver_ops = {
-	.add_device = uhci_add_device,
+	.dev_add = uhci_dev_add,
 };
 /*----------------------------------------------------------------------------*/
@@ -59,7 +59,7 @@
  * @return Error code.
  */
-int uhci_add_device(ddf_dev_t *device)
+int uhci_dev_add(ddf_dev_t *device)
 {
-	usb_log_debug2("uhci_add_device() called\n");
+	usb_log_debug2("uhci_dev_add() called\n");
 	assert(device);
 
